<?php

/*
Widget Name: University of Utah Team Widget
Description: Displays members of your team.
Author: Brian Thurber
Author URI: https://umc.utah.edu
*/

class UU_Team_Widget extends SiteOrigin_Widget {
	function __construct() {

		parent::__construct(
			'uu-team-widget',
			__('University of Utah Team Widget', 'uu-team-widget-text-domain'),
			array(
				'description' => __('Simply and elegantly displays members of your team.', 'uu-team-widget-text-domain'),
			),
			array(

			),
			//form options
			array(
				'uu_team_layout' => array(
					'type' => 'select',
					'label' => __( 'Layout Type', 'uu-team-widget-text-domain' ),
					'default' => 'layout_vertical',
					'options' => array(
						'layout_vertical' => __( 'Vertical', 'uu-team-widget-text-domain' ),
						'layout_vertical_round' => __( 'Vertical Round', 'uu-team-widget-text-domain' ),
						'layout_overlay' => __( 'Overlay', 'uu-team-widget-text-domain' ),
					)
				),
				'uu_team_lightbox' => array(
					'type' => 'checkbox',
					'label' => __( 'Allow Lightbox Popup On Click?', 'uu-team-widget-text-domain' ),
					'default' => false
				),
				'uu_team_color_invert' => array(
					'type' => 'checkbox',
					'label' => __( 'White background with black text', 'uu-team-widget-text-domain' ),
					'default' => false
				),
				'uu_team_photo' => array(
					'type' => 'media',
					'label' => __( 'Choose an image', 'uu-team-widget-text-domain' ),
					'choose' => __( 'Choose image', 'uu-team-widget-text-domain' ),
					'update' => __( 'Set image', 'uu-team-widget-text-domain' ),
					'library' => 'image',//'image', 'audio', 'video', 'file'
					'fallback' => false
				),
				'uu_team_name' => array(
					'type' => 'text',
					'label' => __('Name', 'uu-team-widget-text-domain')
				),
				'uu_team_title' => array(
					'type' => 'text',
					'label' => __('Title', 'uu-team-widget-text-domain')
				),
				'uu_team_description' => array(
					'type' => 'text',
					'label' => __('Description', 'uu-team-widget-text-domain')
				),
				'uu_team_description' => array(
					'type' => 'textarea',
					'label' => __( 'Description (Note: Will only display in lightbox)', 'uu-team-widget-text-domain' ),
					'default' => '',
					'rows' => 5
				),
				'uu_team_phone' => array(
					'type' => 'text',
					'label' => __( 'Phone Number', 'uu-team-widget-text-domain' ),
					'default' => ''
				),
				'uu_team_display_phone' => array(
					'type' => 'checkbox',
					'label' => __( 'Only display phone number in lightbox', 'uu-team-widget-text-domain' ),
					'default' => false
				),
				'uu_team_email' => array(
					'type' => 'text',
					'label' => __('Email', 'uu-team-widget-text-domain'),
					'default' => ''
				),
				'uu_team_display_email' => array(
					'type' => 'checkbox',
					'label' => __( 'Only display email in lightbox', 'uu-team-widget-text-domain' ),
					'default' => false
				),
				'uu_team_address_1' => array(
					'type' => 'text',
					'label' => __('Address 1', 'uu-team-widget-text-domain'),
					'default' => ''
				),
				'uu_team_address_2' => array(
					'type' => 'text',
					'label' => __('Address 2', 'uu-team-widget-text-domain'),
					'default' => ''
				),
				'uu_team_display_address' => array(
					'type' => 'checkbox',
					'label' => __( 'Only display address in lightbox', 'uu-team-widget-text-domain' ),
					'default' => false
				),
			),
			plugin_dir_path(__FILE__)
		);

	}


	function get_template_name($instance) {
		return 'uu-team-widget-template';
	}


	function initialize() {
		$this->register_frontend_scripts(
	        array(
	            array( 'uu-team-widget-scripts', 
	            	plugin_dir_url(__FILE__) . '/js/uu-team-widget.js',
	            	array( 'jquery' ),
	            	 '1.0',
	            	 true 
	            	)
	        )
	    );
		$this->register_frontend_styles(
			array(
				array(
					'uu-team-widget-styles',
					plugin_dir_url(__FILE__) . '/css/uu-team-widget.css',
					array(),
					'1.0'
				),
			)
		);
	}

/*	function get_style_name($instance) {
		return 'uu-team-widget-style';
	}*/



}

siteorigin_widget_register('uu-team-widget', __FILE__, 'UU_Team_Widget');
















