<?php

/*
Widget Name: University of Utah Trumba Widget
Description: Dislpay your Trumba feed anywhere on your site.
Author: Brian Thurber
Author URI: https://umc.utah.edu
*/

class UU_Trumba_Widget extends SiteOrigin_Widget {
	function __construct() {

		parent::__construct(
			'uu-trumba-widget',
			__('University of Utah Trumba Widget', 'uu-trumba-widget-text-domain'),
			array(
				'description' => __('Dislpay your trumba feed anywhere on your site. Just plug in your trumba calendar url.', 'uu-trumba-widget-text-domain'),
			),
			array(

			),
			//form options
			array(
				'uu_trumba_feed_url' => array(
					'type' => 'text',
					'label' => __('Trumba Feed URL', 'uu-trumba-widget-text-domain')
				),
			),
			plugin_dir_path(__FILE__)
		);

	}


	function get_template_name($instance) {
		return 'uu-trumba-widget-template';
	}


	function initialize() {
		$this->register_frontend_scripts(
	        array(
	            array( 'uu-trumba-widget-scripts', 
	            	plugin_dir_url(__FILE__) . '/js/uu-trumba-widget.js',
	            	array( 'jquery' ),
	            	 '1.0',
	            	 true 
	            	)
	        )
	    );
		$this->register_frontend_styles(
			array(
				array(
					'uu-trumba-widget-styles',
					plugin_dir_url(__FILE__) . '/css/uu-trumba-widget.css',
					array(),
					'1.0'
				),
			)
		);
	}

}

siteorigin_widget_register('uu-trumba-widget', __FILE__, 'UU_Trumba_Widget');
















